/*
 * SendingThread.java
 *
 * Created on 26. červenec 2007, 3:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.mgn.collab;

import java.awt.Toolkit;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 *
 * @author lubos
 */
public class SendingThread extends Thread {
    
    protected InputStream fis = null;
    protected InputStream is = null;
    protected OutputStream os = null;
    protected int delka;
    protected boolean sending;
    protected MainFrame mainFrame;
    protected String fileName;
    
    public void run(){
        
        mainFrame.down1.setEnabled(false);
        mainFrame.down2.setEnabled(false);
        mainFrame.down3.setEnabled(false);
        mainFrame.downBtn.setValue(0);
        mainFrame.downBtn.setMaximum(delka);
        
        if (sending == true){
            int part;            
            try {
                while ((part = fis.read()) >= 0){
                    os.write(part);
                    mainFrame.downBtn.setValue(mainFrame.downBtn.getValue()+1);
                }
                os.flush();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        
        if (sending == false){
            try {
                for(int y=0;y<delka;y++) {
                    os.write(is.read());
                    mainFrame.downBtn.setValue(mainFrame.downBtn.getValue()+1);
                }
                os.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
            if(fileName.endsWith(".png")){
                Obrazek okno = new Obrazek();
                okno.setTitle(fileName);
                okno.nactiObrazek("sharedfiles/"+fileName);
                okno.setOkno(okno);
                okno.setPreferredSize(Toolkit.getDefaultToolkit().getScreenSize());
                okno.pack();
                okno.setVisible(true);
            }
            System.out.println("Dostal jsem soubor: "+fileName);
        }
        
        mainFrame.down1.setEnabled(true);
        mainFrame.down2.setEnabled(true);
        mainFrame.down3.setEnabled(true);
        
        mainFrame.downloading = false;
        
        System.out.println("File transfer complete...");
        
        
    }
    
    
    public SendingThread(MainFrame mainFrame, OutputStream os, InputStream fis, int delka) {
        this.mainFrame = mainFrame;
        this.os = os;
        this.fis = fis;
        this.delka = delka;
        sending = true;
    }
    
    public SendingThread(MainFrame mainFrame, OutputStream os,InputStream is, int delka, String fileName) {
        this.mainFrame = mainFrame;
        this.is = is;
        this.delka = delka;
        this.os = os;
        this.fileName = fileName;
        sending = false;
    }
    
    
}
